> ## Documentation Index
> Fetch the complete documentation index at: https://devdocs.xbox.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Login With Facebook Instant Games Id

> Signs the user in using a Facebook Instant Games ID, returning a session identifier that can subsequently be used for API calls which require an authenticated user. Requires Facebook Instant Games to be configured.

## Error codes

This operation may return the following PlayFab errors:

| Error | Code |
| --- | --- |
| EncryptionKeyMissing | 1290 |
| EvaluationModePlayerCountExceeded | 1490 |
| FacebookInstantGamesAuthNotConfiguredForTitle | 1397 |
| InvalidFacebookInstantGamesSignature | 1396 |
| InvalidSignature | 1273 |
| InvalidSignatureTime | 1324 |
| PlayerSecretAlreadyConfigured | 1294 |
| PlayerSecretNotConfigured | 1323 |
| RequestViewConstraintParamsNotAllowed | 1303 |




## OpenAPI

````yaml /services/playfab/api-references/rest/client/client.openapi.json post /Client/LoginWithFacebookInstantGamesId
openapi: 3.0.0
info:
  version: '260922'
  title: PlayFab Client API
  description: >-
    APIs which provide the full range of PlayFab features available to the
    client - authentication, account and data management, inventory, friends,
    matchmaking, reporting, and platform-specific functionality
  termsOfService: https://playfab.com/terms/
  contact:
    url: https://community.playfab.com/index.html
  license:
    name: Apache 2.0
    url: https://github.com/PlayFab/API_Specs/blob/master/LICENSE
servers:
  - url: https://{titleId}.playfabapi.com
    description: PlayFab title endpoint
    variables:
      titleId:
        default: your_title_id
        description: Your PlayFab title ID (hex).
security: []
tags:
  - name: Account Management
    description: Account Management APIs
  - name: Advertising
    description: Advertising APIs
  - name: Analytics
    description: Analytics APIs
  - name: Authentication
    description: Authentication APIs
  - name: Character Data
    description: Character Data APIs
  - name: Characters
    description: Characters APIs
  - name: Content
    description: Content Service APIs
  - name: Friend List Management
    description: Friend List Management APIs
  - name: Matchmaking
    description: Matchmaking APIs
  - name: Platform Specific Methods
    description: Platform Specific Methods APIs
  - name: Player Data Management
    description: Player Data Management APIs
  - name: Player Item Management
    description: Player Item Management APIs
  - name: PlayStream
    description: PlayStream Management APIs
  - name: Server-Side Cloud Script
    description: Server-Side Cloud Script APIs
  - name: Shared Group Data
    description: Shared Group Data APIs
  - name: Title-Wide Data Management
    description: Title-Wide Data Management APIs
  - name: Trading
    description: Trading Management APIs
paths:
  /Client/LoginWithFacebookInstantGamesId:
    post:
      tags:
        - Authentication
      summary: Login With Facebook Instant Games Id
      description: >
        Signs the user in using a Facebook Instant Games ID, returning a session
        identifier that can subsequently be used for API calls which require an
        authenticated user. Requires Facebook Instant Games to be configured.


        ## Error codes


        This operation may return the following PlayFab errors:


        | Error | Code |

        | --- | --- |

        | EncryptionKeyMissing | 1290 |

        | EvaluationModePlayerCountExceeded | 1490 |

        | FacebookInstantGamesAuthNotConfiguredForTitle | 1397 |

        | InvalidFacebookInstantGamesSignature | 1396 |

        | InvalidSignature | 1273 |

        | InvalidSignatureTime | 1324 |

        | PlayerSecretAlreadyConfigured | 1294 |

        | PlayerSecretNotConfigured | 1323 |

        | RequestViewConstraintParamsNotAllowed | 1303 |
      operationId: LoginWithFacebookInstantGamesId
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/LoginWithFacebookInstantGamesIdRequest'
      responses:
        '200':
          $ref: '#/components/responses/LoginResult'
        '400':
          $ref: '#/components/responses/ApiErrorWrapper'
      security: []
components:
  schemas:
    LoginWithFacebookInstantGamesIdRequest:
      type: object
      properties:
        CreateAccount:
          description: >-
            Automatically create a PlayFab account if one is not currently
            linked to this ID.
          type: boolean
        CustomTags:
          description: >-
            The optional custom tags associated with the request (e.g. build
            number, external trace identifiers, etc.).
          type: object
        EncryptedRequest:
          description: >-
            Base64 encoded body that is encrypted with the Title's public RSA
            key.
          type: string
        FacebookInstantGamesSignature:
          description: Facebook Instant Games signature for the user.
          type: string
        InfoRequestParameters:
          allOf:
            - $ref: '#/components/schemas/GetPlayerCombinedInfoRequestParams'
          description: Flags for which pieces of info to return for the user.
        PlayerSecret:
          description: Player secret that is used to verify API request signatures.
          type: string
        TitleId:
          description: >-
            Unique identifier for the title, found in the Settings > Game
            Properties section of the PlayFab developer site when a title has
            been selected.
          type: string
      required:
        - FacebookInstantGamesSignature
        - TitleId
      example:
        FacebookInstantGamesSignature: abcdef
        CreateAccount: false
        TitleId: '144'
    GetPlayerCombinedInfoRequestParams:
      type: object
      properties:
        GetCharacterInventories:
          description: Whether to get character inventories. Defaults to false.
          type: boolean
        GetCharacterList:
          description: Whether to get the list of characters. Defaults to false.
          type: boolean
        GetPlayerProfile:
          description: >-
            Whether to get player profile. Defaults to false. Has no effect for
            a new player.
          type: boolean
        GetPlayerStatistics:
          description: Whether to get player statistics. Defaults to false.
          type: boolean
        GetTitleData:
          description: Whether to get title data. Defaults to false.
          type: boolean
        GetUserAccountInfo:
          description: Whether to get the player's account Info. Defaults to false
          type: boolean
        GetUserData:
          description: Whether to get the player's custom data. Defaults to false
          type: boolean
        GetUserInventory:
          description: Whether to get the player's inventory. Defaults to false
          type: boolean
        GetUserReadOnlyData:
          description: Whether to get the player's read only data. Defaults to false
          type: boolean
        GetUserVirtualCurrency:
          description: >-
            Whether to get the player's virtual currency balances. Defaults to
            false
          type: boolean
        PlayerStatisticNames:
          description: >-
            Specific statistics to retrieve. Leave null to get all keys. Has no
            effect if GetPlayerStatistics is false
          type: array
          items:
            type: string
        ProfileConstraints:
          allOf:
            - $ref: '#/components/schemas/PlayerProfileViewConstraints'
          description: >-
            Specifies the properties to return from the player profile. Defaults
            to returning the player's display name.
        TitleDataKeys:
          description: >-
            Specific keys to search for in the custom data. Leave null to get
            all keys. Has no effect if GetTitleData is false
          type: array
          items:
            type: string
        UserDataKeys:
          description: >-
            Specific keys to search for in the custom data. Leave null to get
            all keys. Has no effect if GetUserData is false
          type: array
          items:
            type: string
        UserReadOnlyDataKeys:
          description: >-
            Specific keys to search for in the custom data. Leave null to get
            all keys. Has no effect if GetUserReadOnlyData is false
          type: array
          items:
            type: string
      required:
        - GetUserAccountInfo
        - GetUserInventory
        - GetUserVirtualCurrency
        - GetUserData
        - GetUserReadOnlyData
        - GetCharacterInventories
        - GetCharacterList
        - GetTitleData
        - GetPlayerStatistics
        - GetPlayerProfile
      example:
        GetUserAccountInfo: true
        GetUserVirtualCurrency: true
        GetUserData: true
        UserDataKeys:
          - preferences
          - progress
    LoginResult:
      type: object
      properties:
        EntityToken:
          allOf:
            - $ref: '#/components/schemas/EntityTokenResponse'
          description: >-
            If LoginTitlePlayerAccountEntity flag is set on the login request
            the title_player_account will also be logged in and returned.
        InfoResultPayload:
          allOf:
            - $ref: '#/components/schemas/GetPlayerCombinedInfoResultPayload'
          description: Results for requested info.
        LastLoginTime:
          description: >-
            The time of this user's previous login. If there was no previous
            login, then it's DateTime.MinValue
          type: string
        NewlyCreated:
          description: True if the master_player_account was newly created on this login.
          type: boolean
        PlayFabId:
          description: Player's unique PlayFabId.
          type: string
        SessionTicket:
          description: >-
            Unique token authorizing the user and game at the server level, for
            the current session.
          type: string
        SettingsForUser:
          allOf:
            - $ref: '#/components/schemas/UserSettings'
          description: Settings specific to this user.
        TreatmentAssignment:
          allOf:
            - $ref: '#/components/schemas/TreatmentAssignment'
          description: The experimentation treatments for this user at the time of login.
      required:
        - NewlyCreated
      example:
        SessionTicket: >-
          50DF92E291CCD4C3---A54F-8D3909FF54DEE10-B7817722BC94E536.A6DCCFE1C9709ABB
        PlayFabId: 50DF92E291CCD4C3
    ApiErrorWrapper:
      description: The basic wrapper around every failed API response
      type: object
      properties:
        code:
          description: Numerical HTTP code
          type: integer
        status:
          description: String HTTP code
          type: string
        error:
          description: Playfab error code
          type: string
        errorCode:
          description: Numerical PlayFab error code
          type: integer
        errorMessage:
          description: Description for the PlayFab errorCode
          type: string
        errorDetails:
          description: Detailed description of individual issues with the request object
          type: object
      required:
        - code
        - errorCode
    PlayerProfileViewConstraints:
      type: object
      properties:
        ShowAvatarUrl:
          description: Whether to show player's avatar URL. Defaults to false
          type: boolean
        ShowBannedUntil:
          description: Whether to show the banned until time. Defaults to false
          type: boolean
        ShowCampaignAttributions:
          description: Whether to show campaign attributions. Defaults to false
          type: boolean
        ShowContactEmailAddresses:
          description: Whether to show contact email addresses. Defaults to false
          type: boolean
        ShowCreated:
          description: Whether to show the created date. Defaults to false
          type: boolean
        ShowDisplayName:
          description: Whether to show the display name. Defaults to false
          type: boolean
        ShowExperimentVariants:
          description: Whether to show player's experiment variants. Defaults to false
          type: boolean
        ShowLastLogin:
          description: Whether to show the last login time. Defaults to false
          type: boolean
        ShowLinkedAccounts:
          description: Whether to show the linked accounts. Defaults to false
          type: boolean
        ShowLocations:
          description: Whether to show player's locations. Defaults to false
          type: boolean
        ShowMemberships:
          description: Whether to show player's membership information. Defaults to false
          type: boolean
        ShowOrigination:
          description: Whether to show origination. Defaults to false
          type: boolean
        ShowPushNotificationRegistrations:
          description: Whether to show push notification registrations. Defaults to false
          type: boolean
        ShowStatistics:
          description: Reserved for future development
          type: boolean
        ShowTags:
          description: Whether to show tags. Defaults to false
          type: boolean
        ShowTotalValueToDateInUsd:
          description: Whether to show the total value to date in usd. Defaults to false
          type: boolean
        ShowValuesToDate:
          description: Whether to show the values to date. Defaults to false
          type: boolean
      required:
        - ShowDisplayName
        - ShowCreated
        - ShowOrigination
        - ShowLastLogin
        - ShowBannedUntil
        - ShowStatistics
        - ShowCampaignAttributions
        - ShowPushNotificationRegistrations
        - ShowLinkedAccounts
        - ShowContactEmailAddresses
        - ShowTotalValueToDateInUsd
        - ShowValuesToDate
        - ShowTags
        - ShowLocations
        - ShowAvatarUrl
        - ShowMemberships
        - ShowExperimentVariants
    EntityTokenResponse:
      type: object
      properties:
        Entity:
          allOf:
            - $ref: '#/components/schemas/EntityKey'
          description: The entity id and type.
        EntityToken:
          description: The token used to set X-EntityToken for all entity based API calls.
          type: string
        TokenExpiration:
          description: The time the token will expire, if it is an expiring token, in UTC.
          type: string
      example:
        EntityToken: lS2hbYH1Gls1KbnlyozHSQBrF4zsq6q006ci9ijSNqQUiiO6xyCQtVrLjsXjdBJ
        TokenExpiration: '2022-01-26T07:24:12Z'
        Entity:
          Id: 174812abf712
          Type: title_player_account
          TypeString: title_player_account
    GetPlayerCombinedInfoResultPayload:
      type: object
      properties:
        AccountInfo:
          allOf:
            - $ref: '#/components/schemas/UserAccountInfo'
          description: Account information for the user. This is always retrieved.
        CharacterInventories:
          description: Inventories for each character for the user.
          type: array
          items:
            $ref: '#/components/schemas/CharacterInventory'
          x-isclass: true
        CharacterList:
          description: List of characters for the user.
          type: array
          items:
            $ref: '#/components/schemas/CharacterResult'
          x-isclass: true
        PlayerProfile:
          allOf:
            - $ref: '#/components/schemas/PlayerProfileModel'
          description: >-
            The profile of the players. This profile is not guaranteed to be
            up-to-date. For a new player, this profile will not exist.
        PlayerStatistics:
          description: List of statistics for this player.
          type: array
          items:
            $ref: '#/components/schemas/StatisticValue'
          x-isclass: true
        TitleData:
          description: Title data for this title.
          type: object
        UserData:
          allOf:
            - $ref: '#/components/schemas/UserDataRecord'
          description: User specific custom data.
        UserDataVersion:
          description: The version of the UserData that was returned.
          type: number
          x-actualtype: uint32
        UserInventory:
          description: Array of inventory items in the user's current inventory.
          type: array
          items:
            $ref: '#/components/schemas/ItemInstance'
          x-isUnordered: true
          x-isclass: true
        UserReadOnlyData:
          allOf:
            - $ref: '#/components/schemas/UserDataRecord'
          description: User specific read-only data.
        UserReadOnlyDataVersion:
          description: The version of the Read-Only UserData that was returned.
          type: number
          x-actualtype: uint32
        UserVirtualCurrency:
          description: Dictionary of virtual currency balance(s) belonging to the user.
          type: object
          x-actualtype: int32
        UserVirtualCurrencyRechargeTimes:
          allOf:
            - $ref: '#/components/schemas/VirtualCurrencyRechargeTime'
          description: Dictionary of remaining times and timestamps for virtual currencies.
      required:
        - UserDataVersion
        - UserReadOnlyDataVersion
      example:
        AccountInfo:
          PlayFabId: 4027527BF22653D1
          Created: '2013-04-07T09:04:28'
          Username: my name
          TitleInfo:
            Origination: IOS
            Created: '2014-01-08T11:03:18'
            LastLogin: '2014-04-07T09:04:28'
            FirstLogin: '2014-01-08T11:03:18'
            TitlePlayerAccount:
              Id: 174812abf712
              Type: title_player_account
              TypeString: title_player_account
          FacebookInfo:
            FacebookId: '23525445454'
          SteamInfo:
            SteamCountry: US
            SteamCurrency: USD
          GameCenterInfo:
            GameCenterId: someone
        UserVirtualCurrency:
          GC: 15
        UserVirtualCurrencyRechargeTimes:
          GC:
            SecondsToRecharge: 3600
            RechargeTime: '2014-01-01T12:00:00'
            RechargeMax: 50
        UserData:
          preferences:
            Value: alpha
            LastUpdated: '2014-08-20T12:30:45'
            Permission: Public
          progress:
            Value: level_twenty
            LastUpdated: '2014-09-01T10:12:30'
        UserDataVersion: 12
        PlayerProfile:
          TitleId: TitleName
          PlayerId: '10931252888739651331'
          Created: '0001-01-01T00:00:00'
          LastLogin: '0001-01-01T00:00:00'
          BannedUntil: '9999-12-31T23:59:59.9999999'
          DisplayName: PlayerDisplayName
          TotalValueToDateInUSD: 0
    UserSettings:
      type: object
      properties:
        GatherDeviceInfo:
          description: >-
            Boolean for whether this player is eligible for gathering device
            info.
          type: boolean
        GatherFocusInfo:
          description: >-
            Boolean for whether this player should report OnFocus play-time
            tracking.
          type: boolean
        NeedsAttribution:
          description: Boolean for whether this player is eligible for ad tracking.
          type: boolean
      required:
        - NeedsAttribution
        - GatherDeviceInfo
        - GatherFocusInfo
    TreatmentAssignment:
      type: object
      properties:
        Variables:
          description: List of the experiment variables.
          type: array
          items:
            $ref: '#/components/schemas/Variable'
          x-isclass: true
        Variants:
          description: List of the experiment variants.
          type: array
          items:
            type: string
    EntityKey:
      description: >-
        Combined entity type and ID structure which uniquely identifies a single
        entity.
      type: object
      properties:
        Id:
          description: Unique ID of the entity.
          type: string
        Type:
          description: >-
            Entity type. See
            https://learn.microsoft.com/gaming/playfab/features/data/entities/available-built-in-entity-types
          type: string
      required:
        - Id
    UserAccountInfo:
      type: object
      properties:
        AndroidDeviceInfo:
          allOf:
            - $ref: '#/components/schemas/UserAndroidDeviceInfo'
          description: >-
            User Android device information, if an Android device has been
            linked
        AppleAccountInfo:
          allOf:
            - $ref: '#/components/schemas/UserAppleIdInfo'
          description: >-
            Sign in with Apple account information, if an Apple account has been
            linked
        BattleNetAccountInfo:
          allOf:
            - $ref: '#/components/schemas/UserBattleNetInfo'
          description: >-
            Battle.net account information, if a Battle.net account has been
            linked
        Created:
          description: Timestamp indicating when the user account was created
          type: string
        CustomIdInfo:
          allOf:
            - $ref: '#/components/schemas/UserCustomIdInfo'
          description: Custom ID information, if a custom ID has been assigned
        FacebookInfo:
          allOf:
            - $ref: '#/components/schemas/UserFacebookInfo'
          description: User Facebook information, if a Facebook account has been linked
        FacebookInstantGamesIdInfo:
          allOf:
            - $ref: '#/components/schemas/UserFacebookInstantGamesIdInfo'
          description: >-
            Facebook Instant Games account information, if a Facebook Instant
            Games account has been linked
        GameCenterInfo:
          allOf:
            - $ref: '#/components/schemas/UserGameCenterInfo'
          description: User Gamecenter information, if a Gamecenter account has been linked
        GoogleInfo:
          allOf:
            - $ref: '#/components/schemas/UserGoogleInfo'
          description: User Google account information, if a Google account has been linked
        GooglePlayGamesInfo:
          allOf:
            - $ref: '#/components/schemas/UserGooglePlayGamesInfo'
          description: >-
            User Google Play Games account information, if a Google Play Games
            account has been linked
        IosDeviceInfo:
          allOf:
            - $ref: '#/components/schemas/UserIosDeviceInfo'
          description: User iOS device information, if an iOS device has been linked
        KongregateInfo:
          allOf:
            - $ref: '#/components/schemas/UserKongregateInfo'
          description: >-
            User Kongregate account information, if a Kongregate account has
            been linked
        NintendoSwitchAccountInfo:
          allOf:
            - $ref: '#/components/schemas/UserNintendoSwitchAccountIdInfo'
          description: >-
            Nintendo Switch account information, if a Nintendo Switch account
            has been linked
        NintendoSwitchDeviceIdInfo:
          allOf:
            - $ref: '#/components/schemas/UserNintendoSwitchDeviceIdInfo'
          description: >-
            Nintendo Switch device information, if a Nintendo Switch device has
            been linked
        OpenIdInfo:
          description: >-
            OpenID Connect information, if any OpenID Connect accounts have been
            linked
          type: array
          items:
            $ref: '#/components/schemas/UserOpenIdInfo'
          x-isclass: true
        PlayFabId:
          description: Unique identifier for the user account
          type: string
        PrivateInfo:
          allOf:
            - $ref: '#/components/schemas/UserPrivateAccountInfo'
          description: Personal information for the user which is considered more sensitive
        PsnInfo:
          allOf:
            - $ref: '#/components/schemas/UserPsnInfo'
          description: >-
            User PlayStation™ Network account information, if a PlayStation™
            Network account has been linked
        ServerCustomIdInfo:
          allOf:
            - $ref: '#/components/schemas/UserServerCustomIdInfo'
          description: >-
            Server Custom ID information, if a server custom ID has been
            assigned
        SteamInfo:
          allOf:
            - $ref: '#/components/schemas/UserSteamInfo'
          description: User Steam information, if a Steam account has been linked
        TitleInfo:
          allOf:
            - $ref: '#/components/schemas/UserTitleInfo'
          description: Title-specific information for the user account
        TwitchInfo:
          allOf:
            - $ref: '#/components/schemas/UserTwitchInfo'
          description: User Twitch account information, if a Twitch account has been linked
        Username:
          description: User account name in the PlayFab service
          type: string
        XboxInfo:
          allOf:
            - $ref: '#/components/schemas/UserXboxInfo'
          description: User XBox account information, if a XBox account has been linked
      required:
        - Created
      example:
        PlayFabId: '10931252888739651331'
        Created: '2013-04-07T09:04:28'
        Username: accountname
        TitleInfo:
          DisplayName: User in-game name
          Origination: IOS
          Created: '2014-01-08T11:03:18'
          LastLogin: '2014-04-07T09:04:28'
          FirstLogin: '2014-01-08T11:03:18'
          TitlePlayerAccount:
            Id: 174812abf712
            Type: title_player_account
            TypeString: title_player_account
        FacebookInfo:
          FacebookId: '23525445454'
        SteamInfo:
          SteamCountry: US
          SteamCurrency: USD
        GameCenterInfo:
          GameCenterId: someone
    CharacterInventory:
      type: object
      properties:
        CharacterId:
          description: The id of this character.
          type: string
        Inventory:
          description: The inventory of this character.
          type: array
          items:
            $ref: '#/components/schemas/ItemInstance'
          x-isclass: true
    CharacterResult:
      type: object
      properties:
        CharacterId:
          description: The id for this character on this player.
          type: string
        CharacterName:
          description: The name of this character.
          type: string
        CharacterType:
          description: The type-string that was given to this character on creation.
          type: string
      example:
        CharacterId: '3345677'
        CharacterName: CoolDude
        CharacterType: StrongWarrior
    PlayerProfileModel:
      type: object
      properties:
        AdCampaignAttributions:
          description: List of advertising campaigns the player has been attributed to
          type: array
          items:
            $ref: '#/components/schemas/AdCampaignAttributionModel'
          x-isclass: true
        AvatarUrl:
          description: URL of the player's avatar image
          type: string
        BannedUntil:
          description: If the player is currently banned, the UTC Date when the ban expires
          type: string
        ContactEmailAddresses:
          description: List of all contact email info associated with the player account
          type: array
          items:
            $ref: '#/components/schemas/ContactEmailInfoModel'
          x-isclass: true
        Created:
          description: Player record created
          type: string
        DisplayName:
          description: Player display name
          type: string
        ExperimentVariants:
          description: >-
            List of experiment variants for the player. Note that these variants
            are not guaranteed to be up-to-date when returned during login
            because the player profile is updated only after login. Instead, use
            the LoginResult.TreatmentAssignment property during login to get the
            correct variants and variables.
          type: array
          items:
            type: string
        LastLogin:
          description: UTC time when the player most recently logged in to the title
          type: string
        LinkedAccounts:
          description: List of all authentication systems linked to this player account
          type: array
          items:
            $ref: '#/components/schemas/LinkedPlatformAccountModel'
          x-isclass: true
        Locations:
          description: >-
            List of geographic locations from which the player has logged in to
            the title
          type: array
          items:
            $ref: '#/components/schemas/LocationModel'
          x-isclass: true
        Memberships:
          description: List of memberships for the player, along with whether are expired.
          type: array
          items:
            $ref: '#/components/schemas/MembershipModel'
          x-isclass: true
        Origination:
          allOf:
            - $ref: '#/components/schemas/LoginIdentityProvider'
          description: Player account origination
        PlayerId:
          description: PlayFab player account unique identifier
          type: string
        PublisherId:
          description: Publisher this player belongs to
          type: string
        PushNotificationRegistrations:
          description: >-
            List of configured end points registered for sending the player push
            notifications
          type: array
          items:
            $ref: '#/components/schemas/PushNotificationRegistrationModel'
          x-isclass: true
        Statistics:
          description: List of leaderboard statistic values for the player
          type: array
          items:
            $ref: '#/components/schemas/StatisticModel'
          x-isclass: true
        Tags:
          description: List of player's tags for segmentation
          type: array
          items:
            $ref: '#/components/schemas/TagModel'
          x-isclass: true
        TitleId:
          description: Title ID this player profile applies to
          type: string
        TotalValueToDateInUSD:
          description: >-
            Sum of the player's purchases made with real-money currencies,
            converted to US dollars equivalent and represented as a whole number
            of cents (1/100 USD). For example, 999 indicates nine dollars and
            ninety-nine cents.
          type: number
          x-actualtype: uint32
        ValuesToDate:
          description: >-
            List of the player's lifetime purchase totals, summed by real-money
            currency
          type: array
          items:
            $ref: '#/components/schemas/ValueToDateModel'
          x-isclass: true
      example:
        TitleId: FFFF
        PlayerId: 1234ABCD
        Created: '2019-02-11T20:23:05'
        LastLogin: '2020-02-11T20:23:05'
        DisplayName: Gudge
    StatisticValue:
      type: object
      properties:
        StatisticName:
          description: unique name of the statistic
          type: string
        Value:
          description: statistic value for the player
          type: number
          x-actualtype: int32
        Version:
          description: >-
            for updates to an existing statistic value for a player, the version
            of the statistic when it was loaded
          type: number
          x-actualtype: uint32
      required:
        - Value
        - Version
      example:
        StatisticName: headshots
        Value: 5
        Version: 2
    UserDataRecord:
      type: object
      properties:
        LastUpdated:
          description: Timestamp for when this data was last updated.
          type: string
        Permission:
          allOf:
            - $ref: '#/components/schemas/UserDataPermission'
          description: >-
            Indicates whether this data can be read by all users (public) or
            only the user (private). This is used for GetUserData requests being
            made by one player about another player.
        Value:
          description: Data stored for the specified user data key.
          type: string
      required:
        - LastUpdated
      example:
        Value: my value
        LastUpdated: '2015-05-15T03:01:09'
        Permission: Public
    ItemInstance:
      description: >-
        A unique instance of an item in a user's inventory. Note, to retrieve
        additional information for an item such as Tags, Description that are
        the same across all instances of the item, a call to GetCatalogItems is
        required. The ItemID of can be matched to a catalog entry, which
        contains the additional information. Also note that Custom Data is only
        set when the User's specific instance has updated the CustomData via a
        call to UpdateUserInventoryItemCustomData. Other fields such as
        UnitPrice and UnitCurrency are only set when the item was granted via a
        purchase.
      type: object
      properties:
        Annotation:
          description: >-
            Game specific comment associated with this instance when it was
            added to the user inventory.
          type: string
        BundleContents:
          description: >-
            Array of unique items that were awarded when this catalog item was
            purchased.
          type: array
          items:
            type: string
        BundleParent:
          description: >-
            Unique identifier for the parent inventory item, as defined in the
            catalog, for object which were added from a bundle or container.
          type: string
        CatalogVersion:
          description: >-
            Catalog version for the inventory item, when this instance was
            created.
          type: string
        CustomData:
          description: >-
            A set of custom key-value pairs on the instance of the inventory
            item, which is not to be confused with the catalog item's custom
            data.
          type: object
        DisplayName:
          description: CatalogItem.DisplayName at the time this item was purchased.
          type: string
        Expiration:
          description: Timestamp for when this instance will expire.
          type: string
        ItemClass:
          description: Class name for the inventory item, as defined in the catalog.
          type: string
        ItemId:
          description: Unique identifier for the inventory item, as defined in the catalog.
          type: string
        ItemInstanceId:
          description: Unique item identifier for this specific instance of the item.
          type: string
        PurchaseDate:
          description: Timestamp for when this instance was purchased.
          type: string
        RemainingUses:
          description: Total number of remaining uses, if this is a consumable item.
          type: number
          x-actualtype: int32
        UnitCurrency:
          description: >-
            Currency type for the cost of the catalog item. Not available when
            granting items.
          type: string
        UnitPrice:
          description: >-
            Cost of the catalog item in the given currency. Not available when
            granting items.
          type: number
          x-actualtype: uint32
        UsesIncrementedBy:
          description: >-
            The number of uses that were added or removed to this item in this
            call.
          type: number
          x-actualtype: int32
      required:
        - UnitPrice
      example:
        ItemId: shield_level_5
        ItemInstanceId: '133713371337'
        ItemClass: shields
        PurchaseDate: '2017-03-07T00:00:00'
        Expiration: '2018-10-01T00:00:00'
        RemainingUses: 10
        Annotation: No Annotation
        CatalogVersion: '5'
        BundleParent: crate block 1
      x-sortKey: ItemInstanceId
    VirtualCurrencyRechargeTime:
      type: object
      properties:
        RechargeMax:
          description: >-
            Maximum value to which the regenerating currency will automatically
            increment. Note that it can exceed this value through use of the
            AddUserVirtualCurrency API call. However, it will not regenerate
            automatically until it has fallen below this value.
          type: number
          x-actualtype: int32
        RechargeTime:
          description: >-
            Server timestamp in UTC indicating the next time the virtual
            currency will be incremented.
          type: string
        SecondsToRecharge:
          description: >-
            Time remaining (in seconds) before the next recharge increment of
            the virtual currency.
          type: number
          x-actualtype: int32
      required:
        - SecondsToRecharge
        - RechargeTime
        - RechargeMax
      example:
        SecondsToRecharge: 3600
        RechargeTime: '2014-01-01T12:00:00'
        RechargeMax: 50
    Variable:
      type: object
      properties:
        Name:
          description: Name of the variable.
          type: string
        Value:
          description: Value of the variable.
          type: string
      required:
        - Name
    UserAndroidDeviceInfo:
      type: object
      properties:
        AndroidDeviceId:
          description: Android device ID
          type: string
    UserAppleIdInfo:
      type: object
      properties:
        AppleSubjectId:
          description: Apple subject ID
          type: string
    UserBattleNetInfo:
      type: object
      properties:
        BattleNetAccountId:
          description: Battle.net identifier
          type: string
        BattleNetBattleTag:
          description: Battle.net display name
          type: string
    UserCustomIdInfo:
      type: object
      properties:
        CustomId:
          description: Custom ID
          type: string
    UserFacebookInfo:
      type: object
      properties:
        FacebookId:
          description: Facebook identifier
          type: string
        FullName:
          description: Facebook full name
          type: string
    UserFacebookInstantGamesIdInfo:
      type: object
      properties:
        FacebookInstantGamesId:
          description: Facebook Instant Games ID
          type: string
    UserGameCenterInfo:
      type: object
      properties:
        GameCenterId:
          description: Gamecenter identifier
          type: string
    UserGoogleInfo:
      type: object
      properties:
        GoogleEmail:
          description: Email address of the Google account
          type: string
        GoogleGender:
          description: Gender information of the Google account
          type: string
        GoogleId:
          description: Google ID
          type: string
        GoogleLocale:
          description: Locale of the Google account
          type: string
        GoogleName:
          description: Name of the Google account user
          type: string
    UserGooglePlayGamesInfo:
      type: object
      properties:
        GooglePlayGamesPlayerAvatarImageUrl:
          description: Avatar image url of the Google Play Games player
          type: string
        GooglePlayGamesPlayerDisplayName:
          description: Display name of the Google Play Games player
          type: string
        GooglePlayGamesPlayerId:
          description: Google Play Games player ID
          type: string
    UserIosDeviceInfo:
      type: object
      properties:
        IosDeviceId:
          description: iOS device ID
          type: string
    UserKongregateInfo:
      type: object
      properties:
        KongregateId:
          description: Kongregate ID
          type: string
        KongregateName:
          description: Kongregate Username
          type: string
    UserNintendoSwitchAccountIdInfo:
      type: object
      properties:
        NintendoSwitchAccountSubjectId:
          description: Nintendo Switch account subject ID
          type: string
    UserNintendoSwitchDeviceIdInfo:
      type: object
      properties:
        NintendoSwitchDeviceId:
          description: Nintendo Switch Device ID
          type: string
    UserOpenIdInfo:
      type: object
      properties:
        ConnectionId:
          description: OpenID Connection ID
          type: string
        Issuer:
          description: OpenID Issuer
          type: string
        Subject:
          description: OpenID Subject
          type: string
    UserPrivateAccountInfo:
      type: object
      properties:
        Email:
          description: user email address
          type: string
    UserPsnInfo:
      type: object
      properties:
        IssuerId:
          description: >-
            Id of the PlayStation™ Network issuer environment this account is
            keyed under. Supply this value as IssuerId when looking the account
            up.
          type: number
          x-actualtype: int32
        PsnAccountId:
          description: PlayStation™ Network account ID
          type: string
        PsnOnlineId:
          description: PlayStation™ Network online ID
          type: string
        PsnSandboxId:
          description: PlayStation™ Network sandbox ID
          type: string
    UserServerCustomIdInfo:
      type: object
      properties:
        CustomId:
          description: Custom ID
          type: string
    UserSteamInfo:
      type: object
      properties:
        SteamActivationStatus:
          allOf:
            - $ref: '#/components/schemas/TitleActivationStatus'
          description: >-
            what stage of game ownership the user is listed as being in, from
            Steam
        SteamCountry:
          description: the country in which the player resides, from Steam data
          type: string
        SteamCurrency:
          allOf:
            - $ref: '#/components/schemas/Currency'
          description: currency type set in the user Steam account
        SteamId:
          description: Steam identifier
          type: string
        SteamName:
          description: Steam display name
          type: string
    UserTitleInfo:
      type: object
      properties:
        AvatarUrl:
          description: URL to the player's avatar.
          type: string
        Created:
          description: >-
            timestamp indicating when the user was first associated with this
            game (this can differ significantly from when the user first
            registered with PlayFab)
          type: string
        DisplayName:
          description: name of the user, as it is displayed in-game
          type: string
        FirstLogin:
          description: >-
            timestamp indicating when the user first signed into this game (this
            can differ from the Created timestamp, as other events, such as
            issuing a beta key to the user, can associate the title to the user)
          type: string
        isBanned:
          description: >-
            boolean indicating whether or not the user is currently banned for a
            title
          type: boolean
        LastLogin:
          description: timestamp for the last user login for this title
          type: string
        Origination:
          allOf:
            - $ref: '#/components/schemas/UserOrigination'
          description: source by which the user first joined the game, if known
        TitlePlayerAccount:
          allOf:
            - $ref: '#/components/schemas/EntityKey'
          description: Title player account entity for this user
      required:
        - Created
    UserTwitchInfo:
      type: object
      properties:
        TwitchId:
          description: Twitch ID
          type: string
        TwitchUserName:
          description: Twitch Username
          type: string
    UserXboxInfo:
      type: object
      properties:
        XboxUserId:
          description: XBox user ID
          type: string
        XboxUserSandbox:
          description: XBox user sandbox
          type: string
    AdCampaignAttributionModel:
      type: object
      properties:
        AttributedAt:
          description: UTC time stamp of attribution
          type: string
        CampaignId:
          description: Attribution campaign identifier
          type: string
        Platform:
          description: Attribution network name
          type: string
      required:
        - AttributedAt
    ContactEmailInfoModel:
      type: object
      properties:
        EmailAddress:
          description: The email address
          type: string
        Name:
          description: The name of the email info data
          type: string
        VerificationStatus:
          allOf:
            - $ref: '#/components/schemas/EmailVerificationStatus'
          description: The verification status of the email
    LinkedPlatformAccountModel:
      type: object
      properties:
        Email:
          description: Linked account email of the user on the platform, if available
          type: string
        Platform:
          allOf:
            - $ref: '#/components/schemas/LoginIdentityProvider'
          description: Authentication platform
        PlatformUserId:
          description: Unique account identifier of the user on the platform
          type: string
        Username:
          description: Linked account username of the user on the platform, if available
          type: string
    LocationModel:
      type: object
      properties:
        City:
          description: City name.
          type: string
        ContinentCode:
          allOf:
            - $ref: '#/components/schemas/ContinentCode'
          description: The two-character continent code for this location
        CountryCode:
          allOf:
            - $ref: '#/components/schemas/CountryCode'
          description: >-
            The two-character ISO 3166-1 country code for the country associated
            with the location
        Latitude:
          description: Latitude coordinate of the geographic location.
          type: number
          x-actualtype: double
        Longitude:
          description: Longitude coordinate of the geographic location.
          type: number
          x-actualtype: double
    MembershipModel:
      type: object
      properties:
        IsActive:
          description: >-
            Whether this membership is active. That is, whether the
            MembershipExpiration time has been reached.
          type: boolean
        MembershipExpiration:
          description: The time this membership expires
          type: string
        MembershipId:
          description: The id of the membership
          type: string
        OverrideExpiration:
          description: >-
            Membership expirations can be explicitly overridden (via game
            manager or the admin api). If this membership has been overridden,
            this will be the new expiration time.
          type: string
        OverrideIsSet:
          description: Whether the override expiration is set.
          type: boolean
          x-GovernsProperty: OverrideExpiration
        Subscriptions:
          description: The list of subscriptions that this player has for this membership
          type: array
          items:
            $ref: '#/components/schemas/SubscriptionModel'
          x-isclass: true
      required:
        - MembershipExpiration
        - IsActive
    LoginIdentityProvider:
      type: string
      enum:
        - Unknown
        - PlayFab
        - Custom
        - GameCenter
        - GooglePlay
        - Steam
        - XBoxLive
        - PSN
        - Kongregate
        - Facebook
        - IOSDevice
        - AndroidDevice
        - Twitch
        - WindowsHello
        - GameServer
        - CustomServer
        - NintendoSwitch
        - FacebookInstantGames
        - OpenIdConnect
        - Apple
        - NintendoSwitchAccount
        - GooglePlayGames
        - XboxMobileStore
        - King
        - BattleNet
    PushNotificationRegistrationModel:
      type: object
      properties:
        NotificationEndpointARN:
          description: Notification configured endpoint
          type: string
        Platform:
          allOf:
            - $ref: '#/components/schemas/PushNotificationPlatform'
          description: Push notification platform
    StatisticModel:
      type: object
      properties:
        Name:
          description: Statistic name
          type: string
        Value:
          description: Statistic value
          type: number
          x-actualtype: int32
        Version:
          description: Statistic version (0 if not a versioned statistic)
          type: number
          x-actualtype: int32
      required:
        - Version
        - Value
    TagModel:
      type: object
      properties:
        TagValue:
          description: Full value of the tag, including namespace
          type: string
    ValueToDateModel:
      type: object
      properties:
        Currency:
          description: ISO 4217 code of the currency used in the purchases
          type: string
        TotalValue:
          description: >-
            Total value of the purchases in a whole number of 1/100 monetary
            units. For example, 999 indicates nine dollars and ninety-nine cents
            when Currency is 'USD')
          type: number
          x-actualtype: uint32
        TotalValueAsDecimal:
          description: >-
            Total value of the purchases in a string representation of decimal
            monetary units. For example, '9.99' indicates nine dollars and
            ninety-nine cents when Currency is 'USD'.
          type: string
      required:
        - TotalValue
    UserDataPermission:
      description: >-
        Indicates whether a given data key is private (readable only by the
        player) or public (readable by all players). When a player makes a
        GetUserData request about another player, only keys marked Public will
        be returned.
      type: string
      enum:
        - Private
        - Public
    TitleActivationStatus:
      type: string
      enum:
        - None
        - ActivatedTitleKey
        - PendingSteam
        - ActivatedSteam
        - RevokedSteam
    Currency:
      type: string
      enum:
        - AED
        - AFN
        - ALL
        - AMD
        - ANG
        - AOA
        - ARS
        - AUD
        - AWG
        - AZN
        - BAM
        - BBD
        - BDT
        - BGN
        - BHD
        - BIF
        - BMD
        - BND
        - BOB
        - BRL
        - BSD
        - BTN
        - BWP
        - BYR
        - BZD
        - CAD
        - CDF
        - CHF
        - CLP
        - CNY
        - COP
        - CRC
        - CUC
        - CUP
        - CVE
        - CZK
        - DJF
        - DKK
        - DOP
        - DZD
        - EGP
        - ERN
        - ETB
        - EUR
        - FJD
        - FKP
        - GBP
        - GEL
        - GGP
        - GHS
        - GIP
        - GMD
        - GNF
        - GTQ
        - GYD
        - HKD
        - HNL
        - HRK
        - HTG
        - HUF
        - IDR
        - ILS
        - IMP
        - INR
        - IQD
        - IRR
        - ISK
        - JEP
        - JMD
        - JOD
        - JPY
        - KES
        - KGS
        - KHR
        - KMF
        - KPW
        - KRW
        - KWD
        - KYD
        - KZT
        - LAK
        - LBP
        - LKR
        - LRD
        - LSL
        - LYD
        - MAD
        - MDL
        - MGA
        - MKD
        - MMK
        - MNT
        - MOP
        - MRO
        - MUR
        - MVR
        - MWK
        - MXN
        - MYR
        - MZN
        - NAD
        - NGN
        - NIO
        - NOK
        - NPR
        - NZD
        - OMR
        - PAB
        - PEN
        - PGK
        - PHP
        - PKR
        - PLN
        - PYG
        - QAR
        - RON
        - RSD
        - RUB
        - RWF
        - SAR
        - SBD
        - SCR
        - SDG
        - SEK
        - SGD
        - SHP
        - SLL
        - SOS
        - SPL
        - SRD
        - STD
        - SVC
        - SYP
        - SZL
        - THB
        - TJS
        - TMT
        - TND
        - TOP
        - TRY
        - TTD
        - TVD
        - TWD
        - TZS
        - UAH
        - UGX
        - USD
        - UYU
        - UZS
        - VEF
        - VND
        - VUV
        - WST
        - XAF
        - XCD
        - XDR
        - XOF
        - XPF
        - YER
        - ZAR
        - ZMW
        - ZWD
    UserOrigination:
      type: string
      enum:
        - Organic
        - Steam
        - Google
        - Amazon
        - Facebook
        - Kongregate
        - GamersFirst
        - Unknown
        - IOS
        - LoadTest
        - Android
        - PSN
        - GameCenter
        - CustomId
        - XboxLive
        - Parse
        - Twitch
        - ServerCustomId
        - NintendoSwitchDeviceId
        - FacebookInstantGamesId
        - OpenIdConnect
        - Apple
        - NintendoSwitchAccount
        - GooglePlayGames
        - XboxMobileStore
        - King
        - BattleNet
    EmailVerificationStatus:
      type: string
      enum:
        - Unverified
        - Pending
        - Confirmed
    ContinentCode:
      type: string
      enum:
        - AF
        - AN
        - AS
        - EU
        - NA
        - OC
        - SA
        - Unknown
    CountryCode:
      type: string
      enum:
        - AF
        - AX
        - AL
        - DZ
        - AS
        - AD
        - AO
        - AI
        - AQ
        - AG
        - AR
        - AM
        - AW
        - AU
        - AT
        - AZ
        - BS
        - BH
        - BD
        - BB
        - BY
        - BE
        - BZ
        - BJ
        - BM
        - BT
        - BO
        - BQ
        - BA
        - BW
        - BV
        - BR
        - IO
        - BN
        - BG
        - BF
        - BI
        - KH
        - CM
        - CA
        - CV
        - KY
        - CF
        - TD
        - CL
        - CN
        - CX
        - CC
        - CO
        - KM
        - CG
        - CD
        - CK
        - CR
        - CI
        - HR
        - CU
        - CW
        - CY
        - CZ
        - DK
        - DJ
        - DM
        - DO
        - EC
        - EG
        - SV
        - GQ
        - ER
        - EE
        - ET
        - FK
        - FO
        - FJ
        - FI
        - FR
        - GF
        - PF
        - TF
        - GA
        - GM
        - GE
        - DE
        - GH
        - GI
        - GR
        - GL
        - GD
        - GP
        - GU
        - GT
        - GG
        - GN
        - GW
        - GY
        - HT
        - HM
        - VA
        - HN
        - HK
        - HU
        - IS
        - IN
        - ID
        - IR
        - IQ
        - IE
        - IM
        - IL
        - IT
        - JM
        - JP
        - JE
        - JO
        - KZ
        - KE
        - KI
        - KP
        - KR
        - KW
        - KG
        - LA
        - LV
        - LB
        - LS
        - LR
        - LY
        - LI
        - LT
        - LU
        - MO
        - MK
        - MG
        - MW
        - MY
        - MV
        - ML
        - MT
        - MH
        - MQ
        - MR
        - MU
        - YT
        - MX
        - FM
        - MD
        - MC
        - MN
        - ME
        - MS
        - MA
        - MZ
        - MM
        - NA
        - NR
        - NP
        - NL
        - NC
        - NZ
        - NI
        - NE
        - NG
        - NU
        - NF
        - MP
        - 'NO'
        - OM
        - PK
        - PW
        - PS
        - PA
        - PG
        - PY
        - PE
        - PH
        - PN
        - PL
        - PT
        - PR
        - QA
        - RE
        - RO
        - RU
        - RW
        - BL
        - SH
        - KN
        - LC
        - MF
        - PM
        - VC
        - WS
        - SM
        - ST
        - SA
        - SN
        - RS
        - SC
        - SL
        - SG
        - SX
        - SK
        - SI
        - SB
        - SO
        - ZA
        - GS
        - SS
        - ES
        - LK
        - SD
        - SR
        - SJ
        - SZ
        - SE
        - CH
        - SY
        - TW
        - TJ
        - TZ
        - TH
        - TL
        - TG
        - TK
        - TO
        - TT
        - TN
        - TR
        - TM
        - TC
        - TV
        - UG
        - UA
        - AE
        - GB
        - US
        - UM
        - UY
        - UZ
        - VU
        - VE
        - VN
        - VG
        - VI
        - WF
        - EH
        - YE
        - ZM
        - ZW
        - Unknown
    SubscriptionModel:
      type: object
      properties:
        Expiration:
          description: When this subscription expires.
          type: string
        InitialSubscriptionTime:
          description: The time the subscription was orignially purchased
          type: string
        IsActive:
          description: >-
            Whether this subscription is currently active. That is, if
            Expiration > now.
          type: boolean
        Status:
          allOf:
            - $ref: '#/components/schemas/SubscriptionProviderStatus'
          description: >-
            The status of this subscription, according to the subscription
            provider.
        SubscriptionId:
          description: The id for this subscription
          type: string
        SubscriptionItemId:
          description: The item id for this subscription from the primary catalog
          type: string
        SubscriptionProvider:
          description: >-
            The provider for this subscription. Apple or Google Play are
            supported today.
          type: string
      required:
        - Expiration
        - IsActive
        - InitialSubscriptionTime
    PushNotificationPlatform:
      type: string
      enum:
        - ApplePushNotificationService
        - GoogleCloudMessaging
    SubscriptionProviderStatus:
      type: string
      enum:
        - NoError
        - Cancelled
        - UnknownError
        - BillingError
        - ProductUnavailable
        - CustomerDidNotAcceptPriceChange
        - FreeTrial
        - PaymentPending
  responses:
    LoginResult:
      description: ''
      content:
        application/json:
          schema:
            type: object
            properties:
              code:
                type: integer
                description: >-
                  The Http status code. If X-ReportErrorAsSuccess header is set
                  to true, this will report the actual http error code.
              status:
                type: string
                description: The Http status code as a string.
              data:
                $ref: '#/components/schemas/LoginResult'
            example:
              code: 200
              status: OK
              data:
                SessionTicket: >-
                  50DF92E291CCD4C3---A54F-8D3909FF54DEE10-B7817722BC94E536.A6DCCFE1C9709ABB
                PlayFabId: 50DF92E291CCD4C3
    ApiErrorWrapper:
      description: This is the outer wrapper for all responses with errors
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ApiErrorWrapper'

````

## Related topics

- [Login With Facebook Instant Games Id](/services/playfab/api-references/rest/client/authentication/login-with-facebook-instant-games-id.md)
- [PFAccountManagementClientUnlinkFacebookInstantGamesIdAsync](/services/playfab/api-references/c/pfaccountmanagement/functions/pfaccountmanagementclientunlinkfacebookinstantgamesidasync.md)
- [PFAccountManagementClientLinkFacebookInstantGamesIdAsync](/services/playfab/api-references/c/pfaccountmanagement/functions/pfaccountmanagementclientlinkfacebookinstantgamesidasync.md)
- [PlayFab Release Notes 2018](/services/playfab/release-notes/2018.md)
- [Link Facebook Instant Games Id](/services/playfab/api-references/rest/client/account-management/link-facebook-instant-games-id.md)
